//
//  FileViewController.m
//  LT Serial
//
//  Created by PINWU KAO on 6/2/14.
//  Copyright (c) 2014 Laird Technologies. All rights reserved.
//

#import "FileViewController.h"
#import "ViewController.h"
#import "FileCellDetail.h"

@interface FileViewController ()
@end

@implementation FileViewController
{
    NSString         *curDir;
    NSArray          *fileModeArray;
    NSMutableArray   *fileNameArray;
    NSMutableArray   *isDirectoryArray;
    NSMutableArray   *fileSizeArray;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }

    return self;
}

- (void)viewDidLoad
{
    [super  viewDidLoad];

    [[UILabel appearanceWhenContainedIn :[UITableViewHeaderFooterView  class],  nil] setFont :[UIFont  boldSystemFontOfSize: 24]];
    fileModeArray = @[@"Local Files", @"From Dropbox", @"To Dropbox", @"Delete File"];
    self.rootView.fileOperationMode  = enuFileLocal;
    [ self list_TextFiles ];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void) viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.selectedRow = -1;
    self.rootView.fileOperationMode  = enuFileLocal;
    // NSLog(@"Pass Here: count =  %d", (int)[fileNameArray count]);
    
}

- (void) viewWillDisappear:(BOOL)animated
{
    if(self.selectedRow >= 0)
    {
        if(self.rootView.isConnected > 0)
        {
            [self.rootView.sendButton setBackgroundColor:[UIColor lightGrayColor]];
            [self.rootView.sendButton setUserInteractionEnabled :YES];
            self.rootView.labelStatus.text = @"";
        }
    }
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 2;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // return [self.rootView.devicePerpArray count];
    if (section == 0)
        return [fileModeArray count] - 1;   // not show the delete mode
    else
        return [fileNameArray count];
}

- (NSString *) tableView:( UITableView *)tableView titleForHeaderInSection:(NSInteger )section {
    NSString *headerTitle =  @"";
    
    if(section == 0)
        headerTitle = @"File Mode";
    else
    {
        if( self.rootView .fileOperationMode  == enuFileLocal)
            headerTitle =  @"Select a Local File";
        else if (self .rootView . fileOperationMode ==  enuFileDownload)
            headerTitle =  @"Download a Dropbox File";
        else if (self .rootView .fileOperationMode  == enuFileUpload)
            headerTitle =  @"Upload a Log File";
        else if (self .rootView .fileOperationMode  == enuFileDelete)
            headerTitle =  @"Delete a Local File";
    }
    
    return headerTitle;
}


- (UITableViewCell *)tableView:( UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath  *)indexPath
{
    static  NSString *myTableIdentifier = @"FileCellDetailID" ;
    // NSLog(@"numberOfRowsInSection: %d", [self.rootView.devicePerpArray count]);
    
    FileCellDetail *cell = [tableView dequeueReusableCellWithIdentifier :myTableIdentifier];
    
    if (cell ==  nil) {
        NSLog(@"cellForRowAtIndexPath 1: cell is nil" );
        // cell = [[DeviceCellDetail alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:myTableIdentifier];
        if ( UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone )
            cell = (FileCellDetail *)[FileCellDetail  cellFromNibNamed: @"FileDetail_iPhone"];
        else if  (UI_USER_INTERFACE_IDIOM() ==  UIUserInterfaceIdiomPad)
            cell = (FileCellDetail *)[FileCellDetail  cellFromNibNamed: @"FileDetail_iPad"];
        
        
        if(cell ==  nil)
            NSLog(@"cellForRowAtIndexPath 2: cell is nil" );
    }
    
    if (indexPath.section == 0)
    {
        NSString *string = [fileModeArray objectAtIndex:indexPath. row];
        cell.fileName.text = string;
        cell.fileSize.text  = @"";
        cell.labelFileName.text = @"";
        cell.labelFileSize.text = @"";
    }
    else if (indexPath.section == 1)
    {
        cell.labelFileName.text = @"File Name:";
        cell.labelFileSize.text = @"Size (bytes):";
        NSString *string = [fileNameArray  objectAtIndex:indexPath. row];
        if( [[ isDirectoryArray objectAtIndex :indexPath.row]  intValue] )
            string = [string  stringByAppendingString:@"/" ];
        
        cell.fileName.text = string;
        [cell.fileSize setTextAlignment  :NSTextAlignmentLeft];
        cell.fileSize.text  = [fileSizeArray objectAtIndex :indexPath.row];
    }
    
    return cell;
}

- (void)tableView:(  UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath   *)indexPath
{
    if(indexPath.section == 0)
    {
        self.rootView .fileOperationMode = (EnuFileModes_t) indexPath.row;
        
        if( self.rootView .fileOperationMode  == enuFileLocal)
        {
            [ self list_TextFiles ];
        }
        else if (self .rootView .fileOperationMode  == enuFileUpload)
        {
            if (![[  DBSession sharedSession  ] isLinked])
            {
                [[  DBSession sharedSession  ] linkFromController:  self];
            }
            
            self.restClient   = [[DBRestClient alloc  ] initWithSession:[  DBSession sharedSession  ]];
            self.restClient .delegate   = (id)self;
            [ self list_LogFiles ];
        }
        else if (self.rootView.fileOperationMode  == enuFileDelete)
        {
            [ self list_TextFiles ];
        }
        else if (self.rootView.fileOperationMode ==  enuFileDownload)
        {
            if (![[  DBSession sharedSession  ] isLinked])
            {
                [[  DBSession sharedSession  ] linkFromController:  self];
            }
            
            self.restClient   = [[DBRestClient alloc  ] initWithSession:[  DBSession sharedSession  ]];
            self.restClient  .delegate  = ( id) self;
            curDir = @"/"  ;
            [ self.restClient   loadMetadata:  curDir];
        }
        
        [self.tableView reloadData];
        return;
    }
    
    self.selectedRow = indexPath.row;
    NSString *fileName = [[NSString alloc  ] initWithString:[  fileNameArray objectAtIndex  :indexPath.row]];
    [self.rootView.fileName  setTextColor :self  .rootView. myGreenColor ];
    
    if(self.rootView.fileOperationMode == enuFileLocal)
    {
        self.rootView.fileName.text = fileName;
        [ self.navigationController  popViewControllerAnimated: YES];
    }
    else if(self.rootView.fileOperationMode == enuFileUpload)
    {
        NSString *localDir = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
        NSString *localPath = [localDir stringByAppendingPathComponent:fileName];
        // Upload file to Dropbox
        NSString *destDir = @"/";
        [self.restClient uploadFile:fileName toPath:destDir withParentRev:nil fromPath:localPath];
    }
    else if(self.rootView.fileOperationMode == enuFileDelete)
    {
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *documentsPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        
        NSString *filePath = [documentsPath stringByAppendingPathComponent:fileName];
        NSError *error;
        BOOL success = [fileManager removeItemAtPath:filePath error:&error];
        if (success) {
            // UIAlertView *removeSuccessFulAlert=[[UIAlertView alloc]initWithTitle:@"Congratulation:" message:@"Successfully removed" delegate:self cancelButtonTitle:@"Close" otherButtonTitles:nil];
            // [removeSuccessFulAlert show];
            [fileNameArray removeObject:[fileNameArray objectAtIndex:self.selectedRow]];
            [isDirectoryArray removeObject:[isDirectoryArray objectAtIndex:self.selectedRow]];
            [fileSizeArray removeObject:[fileSizeArray objectAtIndex:self.selectedRow]];
            [self.tableView reloadData];
        }
        else
        {
            NSLog(@"Could not delete file -:%@ ",[error localizedDescription]);
        }
    }
    else if(self.rootView.fileOperationMode == enuFileDownload)
    {
        if( [fileName  isEqualToString:@".." ] )
        {
            // Get the parent directory as the current directory
            NSString *string = [curDir substringToIndex :curDir .length  - 1];
            NSRange range = [string rangeOfString :@"/"  options:NSBackwardsSearch];
            if(range. location != NSNotFound )
            {
                curDir = [string substringToIndex :range.location +  1];
                [ self.restClient   loadMetadata:  curDir];
            }
        }
        else if ( [[isDirectoryArray  objectAtIndex :indexPath. row]  intValue ] )
        {
            // Open the directory
            curDir = [curDir  stringByAppendingString:fileName];
            curDir = [curDir  stringByAppendingString: @"/"];
            [ self.restClient  loadMetadata: curDir];
        }
        else
        {
            // Download the file from Dropbox
            NSString *localDir = NSSearchPathForDirectoriesInDomains (NSDocumentDirectory , NSUserDomainMask,  YES)[0 ];
            NSString *localPath = [localDir stringByAppendingPathComponent :fileName ];
            
            NSString *dropboxPath = [curDir stringByAppendingString :fileName];
            [ self.restClient loadFile:dropboxPath  intoPath:localPath];
            self.rootView.fileName.text  = fileName;
        }
    }
}

- (IBAction)navigateBack:(id)sender {
    [self.navigationController popViewControllerAnimated:YES];
}

- (void) list_TextFiles
{
    NSFileManager  *fileMgr;
    NSString       *docsDir;
    NSArray        *dirPaths;
    NSArray        *fnameArray;
    
    fileMgr = [NSFileManager defaultManager];
    dirPaths =NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES);
    docsDir = [dirPaths objectAtIndex:0];
    // NSLog(@"docsDir = %@", NSHomeDirectory());
    
    
    NSArray *dirContents = [fileMgr subpathsOfDirectoryAtPath:docsDir error:nil];
    if ([dirContents count] > 0)
    {
        NSPredicate *filter = [NSPredicate predicateWithFormat:@"self ENDSWITH '.txt'"];
        fnameArray = [dirContents filteredArrayUsingPredicate:filter];
    }
    
    fileNameArray = [[NSMutableArray       alloc] init ];
    fileSizeArray = [[NSMutableArray alloc] init];
    
    for (NSString *file in fnameArray)
    {
        NSError *error = nil;
        NSString *path = [docsDir stringByAppendingPathComponent:file];
        NSDictionary *fileAttributes = [fileMgr attributesOfItemAtPath:path error:&error];
        
        
        if(fileAttributes != nil)
        {
            [ fileNameArray addObject:file];
            [ isDirectoryArray addObject :[NSNumber  numberWithBool: NO]];
            NSNumber *fileSize = [fileAttributes objectForKey:NSFileSize];
            long myFileSize = [fileSize longValue];
            NSString *fileSizeString = [NSString stringWithFormat:@"%ld", myFileSize];
            [fileSizeArray addObject:fileSizeString];
        }
    }
}

- (void) list_LogFiles
{
    NSFileManager  *fileMgr;
    NSString       *docsDir;
    NSArray        *dirPaths;
    NSArray        *fnameArray;
    
    fileMgr = [NSFileManager defaultManager];
    dirPaths =NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES);
    docsDir = [dirPaths objectAtIndex:0];
    // NSLog(@"docsDir = %@", NSHomeDirectory());
    
    
    NSArray *dirContents = [fileMgr subpathsOfDirectoryAtPath:docsDir error:nil];
    if ([dirContents count] > 0)
    {
        NSPredicate *filter = [NSPredicate predicateWithFormat:@"self ENDSWITH '.log'"];
        fnameArray = [dirContents filteredArrayUsingPredicate:filter];
    }
    
    fileNameArray = [[NSMutableArray alloc] init];
    fileSizeArray = [[NSMutableArray alloc] init];
    
    for (NSString *file in fnameArray)
    {
        NSError *error = nil;
        NSString *path = [docsDir stringByAppendingPathComponent:file];
        NSDictionary *fileAttributes = [fileMgr attributesOfItemAtPath:path error:&error];
        
        
        if(fileAttributes != nil)
        {
            [ fileNameArray addObject:file];
            [ isDirectoryArray addObject :[NSNumber  numberWithBool: NO]];
            NSNumber *fileSize = [fileAttributes objectForKey:NSFileSize];
            long myFileSize = [fileSize longValue];
            NSString *fileSizeString = [NSString stringWithFormat:@"%ld", myFileSize];
            [fileSizeArray addObject:fileSizeString];
        }
    }
}

- (void) list_AllFiles
{
    NSFileManager  *fileMgr;
    NSString       *docsDir;
    NSArray        *dirPaths;
    NSArray        *fnameArray;
    
    fileMgr = [NSFileManager defaultManager];
    dirPaths =NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES);
    docsDir = [dirPaths objectAtIndex:0];
    // NSLog(@"docsDir = %@", NSHomeDirectory());
    
    
    fnameArray = [fileMgr subpathsOfDirectoryAtPath:docsDir error:nil];
    fileNameArray = [[NSMutableArray       alloc] init ];
    fileSizeArray = [[NSMutableArray alloc] init];
    
    for (NSString *file in fnameArray)
    {
        NSError *error = nil;
        NSString *path = [docsDir stringByAppendingPathComponent:file];
        NSDictionary *fileAttributes = [fileMgr attributesOfItemAtPath:path error:&error];
        
        
        if(fileAttributes != nil)
        {
            [ fileNameArray addObject:file];
            [ isDirectoryArray addObject :[NSNumber  numberWithBool: NO]];
            NSNumber *fileSize = [fileAttributes objectForKey:NSFileSize];
            long myFileSize = [fileSize longValue];
            NSString *fileSizeString = [NSString stringWithFormat:@"%ld", myFileSize];
            [fileSizeArray addObject:fileSizeString];
        }
    }
}

#pragma mark DBRestClientDelegate methods

- (void) restClient:(DBRestClient *)client loadedMetadata:(DBMetadata *)metadata {
    if (metadata.isDirectory) {
        // NSLog(@"Folder '%@' contains:", metadata.path);
        fileNameArray  = [[NSMutableArray  alloc] init ];
        isDirectoryArray = [[NSMutableArray  alloc] init ];
        fileSizeArray  = [[NSMutableArray  alloc] init ];

        // If the curDir is not the root, add the parent object
        BOOL isRoot = [curDir isEqualToString:@"/"];
        if(!isRoot)
        {
            NSString  *string = @"..";
            [fileNameArray addObject :string];
            [isDirectoryArray addObject :[NSNumber  numberWithBool:YES ]];
            string = @"-1";
            [fileSizeArray addObject  :string];
        }
        
        for (DBMetadata *file in metadata.contents) {
            // NSLog(@" %@", file.filename);
            NSString  *string;
            [fileNameArray    addObject:file.filename];
            if( file.isDirectory ) [isDirectoryArray addObject:[NSNumber numberWithBool:YES]];
            else [isDirectoryArray addObject:[NSNumber numberWithBool:NO]];
            
            long  value = (long)file.totalBytes;
            string = [ NSString stringWithFormat :@"%ld" , value];
            [fileSizeArray addObject :string];
        }

        [self.tableView reloadData];
    }
}

- (void)restClient:(DBRestClient *)client loadMetadataFailedWithError:(NSError *)error {
    NSLog(@"Error loading metadata: %@", error);
}

- (void) restClient:(DBRestClient *)client loadedFile:( NSString *)localPath
        contentType:( NSString *)contentType metadata:(DBMetadata *)metadata {
    NSLog(@"File loaded into path: %@", localPath);
    [self.navigationController  popViewControllerAnimated:YES ];
}

- (void)restClient:( DBRestClient *)client loadFileFailedWithError:(NSError *)error {
    NSLog(@"There was an error loading the file: %@", error);
    self.rootView.fileName.text  = @"";
    // [self.navigationController  popViewControllerAnimated:YES ];
}

- (void)restClient:(DBRestClient *)client uploadedFile:(NSString *)destPath
              from:(NSString *)srcPath metadata:(DBMetadata *)metadata {
    NSLog(@"File uploaded successfully to path: %@", metadata.path);
    [self.tableView deselectRowAtIndexPath:[self.tableView indexPathForSelectedRow] animated:YES];
}

- (void)restClient:(DBRestClient *)client uploadFileFailedWithError:(NSError *)error {
    NSLog(@"File upload failed with error: %@", error);
}

@end
