//
//  ViewController.h
//  nRF UART
//
//  Created by Ole Morten on 1/11/13.
//  Copyright (c) 2013 Nordic Semiconductor. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "UARTPeripheral.h"
#import "ComboBox.h"

#define MAX_SCAN_DEVICES  10
#define MAX_SCAN_TIME     10
#define MIN_SCAN_TIME      5

@interface ViewController : UIViewController <UITextFieldDelegate, CBCentralManagerDelegate, UARTPeripheralDelegate>
{
    ComboBox *comboFileMode;
}

typedef NS_ENUM(NSInteger, EnuFileModes_t)
{
    enuFileLocal = 0,
    enuFileDownload,
    enuFileUpload,
    enuFileDelete
};

@property (weak, nonatomic) IBOutlet UIButton *aboutButton;
@property (weak, nonatomic) IBOutlet UILabel *labelVersion;
@property (weak, nonatomic) IBOutlet UIImageView *myNavigationBar;
@property (weak, nonatomic) IBOutlet UILabel *fileName;
@property (weak, nonatomic) IBOutlet UILabel *labelStatus;
@property (weak, nonatomic) IBOutlet UILabel *labelService;
@property (weak, nonatomic) IBOutlet UILabel *labelError;
@property (weak, nonatomic) IBOutlet UILabel *labelDropbox;
@property (weak, nonatomic) IBOutlet UIProgressView *progressSending;
@property (weak, nonatomic) IBOutlet UILabel *labelProgress;

@property (weak, nonatomic) IBOutlet UITextView *consoleTextView;
@property (weak, nonatomic) IBOutlet UIButton *connectButton;
@property (weak, nonatomic) IBOutlet UIButton *sendButton;
@property (weak, nonatomic) IBOutlet UIButton *stopButton;
@property (weak, nonatomic) IBOutlet UISwitch *switchDropbox;
@property (weak, nonatomic) IBOutlet UIButton *selectButton;

@property (nonatomic, strong) NSMutableArray  *devicePerpArray;
@property (nonatomic, strong) NSMutableArray  *deviceRssiArray;
@property UIColor     *myRedColor;
@property UIColor     *myBlueColor;
@property UIColor     *myGreenColor;
@property NSUInteger   rcvTimerCount;
@property NSUInteger   scanComplete;
@property NSUInteger   isConnected;
@property NSUInteger   isConnectButtonBusy;
@property EnuFileModes_t  fileOperationMode;

- (IBAction)selectFilePressed:(id)sender;
// - (IBAction)aboutApp:(id)sender;
- (IBAction)connectButtonPressed:(id)sender;
- (IBAction)sendButtonPressed:(id)sender;
- (IBAction)stopButtonPressed:(id)sender;
- (IBAction)aboutButtonPressed:(id)sender;

- (void) makeBtConnection:(NSInteger)index;
- (void) stopBtScan;

@end
